MODULE CopyrightBundle;
(* Generated by m3bundle; see its manpage. *)

IMPORT Bundle, BundleRep, Text;
IMPORT Thread, Wr, TextWr;

TYPE T = Bundle.T OBJECT OVERRIDES
           get      := LookUp;
           getNames := GetNames;
         END;

TYPE Texts = REF ARRAY OF TEXT;

VAR
  bundle: T     := NIL;
  names : Texts := NIL;

PROCEDURE Get(): Bundle.T =
  BEGIN
    IF (bundle = NIL) THEN bundle := NEW (T) END;
    RETURN bundle;
  END Get;

PROCEDURE GetNames (<*UNUSED*> self: T): Texts = 
  BEGIN
    IF names = NIL THEN
      names := NEW (Texts, NUMBER (Names));
      names^ := Names;
    END;
    RETURN names;
  END GetNames;

PROCEDURE LookUp (<*UNUSED*> self: T;  element: TEXT): TEXT = 
  BEGIN
    FOR i := 0 TO LAST (Names)-1 DO
      IF Text.Equal (Names[i], element) THEN
        IF Elements[i] = NIL THEN Elements[i] := GetElt (i) END;
        RETURN Elements[i];
      END;
    END;
    RETURN NIL;
  END LookUp;

CONST Names = ARRAY [0..1] OF TEXT {
  "compact-copyrights.txt",
  NIL
};

VAR Elements := ARRAY [0..1] OF TEXT {
  NIL (* E0 .. E0_2 *),
  NIL
};

PROCEDURE GetElt (n: INTEGER): TEXT =
  <*FATAL Thread.Alerted, Wr.Failure *>
  VAR wr := TextWr.New ();
  BEGIN
    CASE n OF
    | 0 =>
        Wr.PutText (wr, E0);
        Wr.PutText (wr, E0_0);
        Wr.PutText (wr, E0_1);
        Wr.PutText (wr, E0_2);
    ELSE (*skip*)
    END;
    RETURN TextWr.ToText (wr);
  END GetElt;

CONST E0 = 
   "\nElego ComPact Copyrights Documents\n\nComPact Development Team\n\n   "
 & "Copyright \251 1998, 1999, 2000 by Elego Wich GmbH, Berlin, Germany,\n "
 & "  since 10/2000 elego Software Solutions GmbH, Berlin, Germany\n   Copy"
 & "right \251 2001, 2002, 2003 elego Software Solutions GmbH, Berlin, Germ"
 & "any\n   \n   The software Elego ComPact and all accompanying manuals ar"
 & "e furnished\n   under license and may only be used or copied in accorda"
 & "nce with the\n   terms of such license. Basically, ComPact consists of "
 & "some programs\n   and manuals that are free for private and non-commerc"
 & "ial use, and some\n   that need to be purchased. The general license do"
 & "cuments can be found\n   below.\n\n   This is the FREE version of Elego"
 & " ComPact.\n   \n   For more information regarding the details of that l"
 & "icense, Elego ComPact\n   itself, and other Elego products and services"
 & ", contact us at:\n   \n         elego Software Solutions GmbH\n        "
 & " email: info@elego.de\n         www: http://www.elego.de\n         or: "
 & "http://www.elegosoft.com\n         Gustav-Meyer-Allee 25 / Building 12\n"
 & "         13355 Berlin\n         Germany\n         phone: +49 30 23 45 8"
 & "6 96\n         fax: +49 30 23 45 86 95\n   \n   This product includes s"
 & "oftware developed by John D. Polstra.\n   \n   This product includes so"
 & "ftware developed by the University of\n   California, Berkeley and its "
 & "contributors.\n   \n   This product includes software developed by the "
 & "System Research Center\n   of Digital Equipment Corporation, now owned "
 & "by Compaq.\n     ______________________________________________________"
 & "___________\n   \n   Elego ComPact Free License Agreement\n\n 1. Grant "
 & "Of License.  elego Software Solutions GmbH,\n    Gustav-Meyer-Allee 25 "
 & "/ Building 12, 13355 Berlin, Germany\n    (\"ELEGO\"), grants to you (\""
 & "LICENSEE\") the non-exclusive,\n    non-transferable, royalty free righ"
 & "t to use, modify, reproduce and\n    distribute Elego ComPact Light (\""
 & "SOFTWARE\") subject to the\n    terms set forth herein.  Any distributi"
 & "on of SOFTWARE shall\n    include this Elego ComPact Free License Agre";

CONST E0_0 = 
   "ement in human readable\n    form.\n\n 2. Title to Intellectual Propert"
 & "y and Software.  Subject to the\n    limited rights and licenses grante"
 & "d under this License Agreement,\n    all rights, title and interests in"
 & "cluding patent, copyright, and\n    trademark rights in SOFTWARE are an"
 & "d shall remain vested in\n    ELEGO to the exclusion of LICENSEE.  ELEG"
 & "O\n    represents and warrants that ELEGO has the legal right to\n    g"
 & "rant such licenses as are expressly granted under this Agreement.\n\n 3"
 & ". Copyright.  The SOFTWARE is owned by ELEGO or its\n    suppliers and "
 & "is protected by United States copyright laws and\n    international tre"
 & "aty provisions.  Therefore, you must treat the\n    SOFTWARE like any o"
 & "ther copyrighted material (e.g., a book or\n    musical recording) exce"
 & "pt that you may use the SOFTWARE as\n    provided in this Elego ComPact"
 & " Free License Agreement.\n\n 4. Improvements.  LICENSEE hereby grants t"
 & "o ELEGO a\n    non-exclusive, non-transferable, royalty free right to u"
 & "se,\n    modify, reproduce and distribute with the right to sublicense "
 & "at\n    any tier, any improvements, enhancements, extensions, or\n    m"
 & "odifications that LICENSEE make to SOFTWARE, provided such are\n    ret"
 & "urned to ELEGO by LICENSEE.\n\n 5. DISCLAIMER OF WARRANTY.  Because the"
 & " SOFTWARE is a research work\n    and not a released product, it is pro"
 & "vided \"AS IS\" WITHOUT\n    WARRANTY OF ANY KIND AND WITHOUT ANY SUPPO"
 & "RT SERVICES.  EXCEPT AS\n    SPECIFICALLY PROVIDED ABOVE IN SECTION 2, "
 & "ELEGO FURTHER\n    DISCLAIMS ALL OTHER EXPRESS OR IMPLIED WARRANTIES OF"
 & "\n    MERCHANTABILITY OR OF FITNESS FOR A PARTICULAR PURPOSE.  THE\n   "
 & " ENTIRE RISK ARISING OUT OF THE USE OR PERFORMANCE OF THE SOFTWARE\n   "
 & " REMAINS WITH YOU.\n\n 6. Limitation of Liability.  IN NO EVENT SHALL E"
 & "LEGO OR ITS\n    SUPPLIERS BE LIABLE IN AN AMOUNT THAT EXCEEDS THE LICE"
 & "NSE FEE PAID\n    BY LICENSEE FOR ANY DAMAGES (INCLUDING, WITH LIMITATI"
 & "ON, DAMAGES\n    FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, L"
 & "OSS OF\n    BUSINESS INFORMATION, OR OTHER PECUNIARY";

CONST E0_1 = 
   " LOSS), REGARDLESS OF THE\n    FORM OF CLAIM OR ACTIONS, ARISING OUT OF"
 & " THE USE OF OR INABILITY\n    TO USE THE SOFTWARE OR DOCUMENTATION, EVE"
 & "N IF ELEGO HAS\n    BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  B"
 & "ECAUSE SOME\n    STATES DO NOT ALLOW THE EXCLUSION OR LIMITATION OF LIA"
 & "BILITY FOR\n    CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE ABOVE LIMITATI"
 & "ON MAY NOT\n    APPLY TO YOU.\n\n 7. Acknowledgement of Allocation of R"
 & "isk.  LICENSEE acknowledges and\n    agrees that the fees charged by EL"
 & "EGO in this Agreement\n    reflect the allocation of risks provided by "
 & "the foregoing\n    limitation of liability.  LICENSEE acknowledges and "
 & "represents\n    that it has read and understands these allocations of r"
 & "isk\n    limiting the liability of ELEGO and that it understands\n    t"
 & "hat a modification of the allocation of risks set forth in this\n    ag"
 & "reement would affect the fees charged by ELEGO, and that\n    LICENSEE,"
 & " in consideration of such fees, agrees to such\n    allocations of risk"
 & ".\n\n 8. LICENSEE INDEMNIFICATION.  LICENSEE SHALL INDEMNIFY ELEGO\n   "
 & " AGAINST ALL COSTS AND DAMAGE JUDGEMENTS, INCLUDING ATTORNEY\'S FEES\n "
 & "   AND COSTS OF DEFENSE, INCURRED BECAUSE OF CLAIMS OF DAMAGE ARISING\n"
 & "    FROM LICENSEE\'S POSSESSION OR USE OR INABILITY TO USE SOFTWARE.\n\n"
 & " 9. GOVERNMENT RESTRICTED RIGHTS.  The SOFTWARE and documentation are\n"
 & "    provided with RESTRICTED RIGHTS.  Use duplication, or disclosure\n "
 & "   by the Government is subject restrictions as set forth in\n    subpa"
 & "ragraph (c)(1)(ii) of The Rights in Technical Data and\n    Computer So"
 & "ftware clause in DFARS 252.227-7013, or subparagraphs\n    (c)(i) and ("
 & "2) of the Commercial Computer Software -- Restricted\n    Rights at 48 "
 & "CFR 52.227-19, as applicable.  Manufacturer is\n    elego Software Solu"
 & "tions GmbH, Gustav-Meyer-Allee 25 / Building\n    12, 13355 Berlin, Ger"
 & "many.\n\n10. Severability.  If any provision of the Agreement is held i"
 & "llegal\n    or unenforceable by any court of competent jurisdiction, su"
 & "ch\n    provision shall be deemed separable from ";

CONST E0_2 = 
   "the remaining provisions\n    of this Agreement and shall not affect or"
 & " impair the validity or\n    enforceability of the remaining provisions"
 & " of this Agreement.\n\n11. Governing Law.  This Agreement is governed b"
 & "y the laws of the\n    Federal Republic of Germany.\n\n12. Publicity.  "
 & "You my not use the name of ELEGO in any\n    advertisement, press relea"
 & "se or other publicity with reference to\n    Elego Compact without prio"
 & "r written consent of ELEGO.\n\n";


BEGIN
END CopyrightBundle.
