(* Copyright (C) 1995, Digital Equipment Corporation.       *)
(* All rights reserved.                                     *)
(* See the file COPYRIGHT for a full description.           *)
(*                                                          *)
(* Last modified on Thu Feb  9 08:56:54 PST 1995 by kalsow  *)
(*      modified on Sat Jun  4 16:23:08 1994 by heydon      *)
(*      modified on Wed Feb 17 17:04:32 PST 1993 by johnh   *)
(*      modified on Tue Jun  9 00:35:35 1992 by mhb         *)

(*********************************************************************
|*  NOTE: This file is generated automatically from the event
|*        definition file CP.evt.
|*********************************************************************)

<* PRAGMA LL *>

MODULE CPViewClass;

<*NOWARN*> IMPORT CPAlgClass, ZeusClass, R2, ViewClass;

REVEAL
  T = Public BRANDED OBJECT
      OVERRIDES
        <* LL.sup = VBT.mu *>
        isCompat := IsCompat;
        <* LL.sup < VBT.mu *>
        oeSetup := Setup;
        oeAddPoint := AddPoint;
        oeNotProcessed := NotProcessed;
        oeRemoveNotProcessed := RemoveNotProcessed;
        oeActiveR := ActiveR;
        oeRemoveActiveR := RemoveActiveR;
        oeCloseR := CloseR;
        oeRemoveCloseR := RemoveCloseR;
        oeSplit := Split;
        oeSplitRemove := SplitRemove;
        oeNewMin := NewMin;
        oeNoChangeMin := NoChangeMin;
        oeSelectTrialPoint := SelectTrialPoint;
        oeDeselectTrialPoint := DeselectTrialPoint;
        oeSelectTargetPoint := SelectTargetPoint;
        oeDeselectTargetPoint := DeselectTargetPoint;
        oeDrawBar := DrawBar;
        oeRemoveBar := RemoveBar;
        <* LL.sup = VBT.mu *>
      END;

PROCEDURE IsCompat(<*UNUSED*> v: T; alg: ZeusClass.T): BOOLEAN =
  <* LL.sup = VBT.mu *>
  BEGIN
    RETURN ISTYPE(alg, CPAlgClass.T)
  END IsCompat;

PROCEDURE Setup (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Setup;
PROCEDURE AddPoint (view: T
    ; <*UNUSED*> p: R2.T
    ; <*UNUSED*> N: INTEGER
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END AddPoint;
PROCEDURE NotProcessed (view: T
    ; <*UNUSED*> x1: REAL
    ; <*UNUSED*> x2: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NotProcessed;
PROCEDURE RemoveNotProcessed (view: T
    ; <*UNUSED*> x1: REAL
    ; <*UNUSED*> x2: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END RemoveNotProcessed;
PROCEDURE ActiveR (view: T
    ; <*UNUSED*> x1: REAL
    ; <*UNUSED*> x2: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END ActiveR;
PROCEDURE RemoveActiveR (view: T
    ; <*UNUSED*> x1: REAL
    ; <*UNUSED*> x2: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END RemoveActiveR;
PROCEDURE CloseR (view: T
    ; <*UNUSED*> x1: REAL
    ; <*UNUSED*> x2: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END CloseR;
PROCEDURE RemoveCloseR (view: T
    ; <*UNUSED*> x1: REAL
    ; <*UNUSED*> x2: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END RemoveCloseR;
PROCEDURE Split (view: T
    ; <*UNUSED*> x: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Split;
PROCEDURE SplitRemove (view: T
    ; <*UNUSED*> x: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END SplitRemove;
PROCEDURE NewMin (view: T
    ; <*UNUSED*> p1: R2.T
    ; <*UNUSED*> p2: R2.T
    ; <*UNUSED*> c1: R2.T
    ; <*UNUSED*> c2: R2.T
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewMin;
PROCEDURE NoChangeMin (view: T
    ; <*UNUSED*> p1: R2.T
    ; <*UNUSED*> p2: R2.T
    ; <*UNUSED*> c1: R2.T
    ; <*UNUSED*> c2: R2.T
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NoChangeMin;
PROCEDURE SelectTrialPoint (view: T
    ; <*UNUSED*> x: R2.T
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END SelectTrialPoint;
PROCEDURE DeselectTrialPoint (view: T
    ; <*UNUSED*> x: R2.T
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END DeselectTrialPoint;
PROCEDURE SelectTargetPoint (view: T
    ; <*UNUSED*> trialp: R2.T
    ; <*UNUSED*> targp: R2.T
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END SelectTargetPoint;
PROCEDURE DeselectTargetPoint (view: T
    ; <*UNUSED*> trialp: R2.T
    ; <*UNUSED*> targp: R2.T
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END DeselectTargetPoint;
PROCEDURE DrawBar (view: T
    ; <*UNUSED*> y: REAL
    ; <*UNUSED*> x1: REAL
    ; <*UNUSED*> x2: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END DrawBar;
PROCEDURE RemoveBar (view: T
    ; <*UNUSED*> y: REAL
    ; <*UNUSED*> x1: REAL
    ; <*UNUSED*> x2: REAL
    ; <*UNUSED*> big: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END RemoveBar;


BEGIN
END CPViewClass.
