(* Copyright (C) 1995, Digital Equipment Corporation.       *)
(* All rights reserved.                                     *)
(* See the file COPYRIGHT for a full description.           *)
(*                                                          *)
(* Last modified on Thu Feb  9 08:56:54 PST 1995 by kalsow  *)
(*      modified on Sat Jun  4 16:23:08 1994 by heydon      *)
(*      modified on Wed Feb 17 17:04:32 PST 1993 by johnh   *)
(*      modified on Tue Jun  9 00:35:35 1992 by mhb         *)

(*********************************************************************
|*  NOTE: This file is generated automatically from the event
|*        definition file Euclid.evt.
|*********************************************************************)

<* PRAGMA LL *>

MODULE EuclidViewClass;

<*NOWARN*> IMPORT ZeusClass, Euclid, EuclidAlgClass, ViewClass;

REVEAL
  T = Public BRANDED OBJECT
      OVERRIDES
        <* LL.sup = VBT.mu *>
        isCompat := IsCompat;
        <* LL.sup < VBT.mu *>
        oeSetupTriangle := SetupTriangle;
        oeSetupSquare := SetupSquare;
        oeLineAL := LineAL;
        oeTriangle := Triangle;
        oeQuad := Quad;
        oeShear := Shear;
        oeRotateTriangle := RotateTriangle;
        oeRotateLine := RotateLine;
        oeRotateAngle := RotateAngle;
        oeHighlightLine := HighlightLine;
        oeHighlightAngle := HighlightAngle;
        oeRemove := Remove;
        oeStep := Step;
        <* LL.sup = VBT.mu *>
      END;

PROCEDURE IsCompat(<*UNUSED*> v: T; alg: ZeusClass.T): BOOLEAN =
  <* LL.sup = VBT.mu *>
  BEGIN
    RETURN ISTYPE(alg, EuclidAlgClass.T)
  END IsCompat;

PROCEDURE SetupTriangle (view: T
    ; <*UNUSED*> a: REAL
    ; <*UNUSED*> b: REAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END SetupTriangle;
PROCEDURE SetupSquare (view: T
    ; <*UNUSED*> p1: Euclid.Id
    ; <*UNUSED*> p2: Euclid.Id
    ; <*UNUSED*> p3: Euclid.Id
    ; <*UNUSED*> p4: Euclid.Id
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END SetupSquare;
PROCEDURE LineAL (view: T
    ; <*UNUSED*> show: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END LineAL;
PROCEDURE Triangle (view: T
    ; <*UNUSED*> p1: Euclid.Id
    ; <*UNUSED*> p2: Euclid.Id
    ; <*UNUSED*> p3: Euclid.Id
    ; <*UNUSED*> color: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Triangle;
PROCEDURE Quad (view: T
    ; <*UNUSED*> p1: Euclid.Id
    ; <*UNUSED*> p2: Euclid.Id
    ; <*UNUSED*> p3: Euclid.Id
    ; <*UNUSED*> p4: Euclid.Id
    ; <*UNUSED*> color: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Quad;
PROCEDURE Shear (view: T
    ; <*UNUSED*> p1: Euclid.Id
    ; <*UNUSED*> p2: Euclid.Id
    ; <*UNUSED*> from: Euclid.Id
    ; <*UNUSED*> to: Euclid.Id
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Shear;
PROCEDURE RotateTriangle (view: T
    ; <*UNUSED*> pivot: Euclid.Id
    ; <*UNUSED*> p1From: Euclid.Id
    ; <*UNUSED*> p1To: Euclid.Id
    ; <*UNUSED*> p2From: Euclid.Id
    ; <*UNUSED*> pt2To: Euclid.Id
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END RotateTriangle;
PROCEDURE RotateLine (view: T
    ; <*UNUSED*> pivot: Euclid.Id
    ; <*UNUSED*> pFrom: Euclid.Id
    ; <*UNUSED*> pTo: Euclid.Id
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END RotateLine;
PROCEDURE RotateAngle (view: T
    ; <*UNUSED*> pivot: Euclid.Id
    ; <*UNUSED*> p1From: Euclid.Id
    ; <*UNUSED*> p1To: Euclid.Id
    ; <*UNUSED*> p2From: Euclid.Id
    ; <*UNUSED*> pt2To: Euclid.Id
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END RotateAngle;
PROCEDURE HighlightLine (view: T
    ; <*UNUSED*> p1: Euclid.Id
    ; <*UNUSED*> p2: Euclid.Id
    ; <*UNUSED*> value: INTEGER
    ; <*UNUSED*> show: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END HighlightLine;
PROCEDURE HighlightAngle (view: T
    ; <*UNUSED*> p1: Euclid.Id
    ; <*UNUSED*> vertex: Euclid.Id
    ; <*UNUSED*> p2: Euclid.Id
    ; <*UNUSED*> value: INTEGER
    ; <*UNUSED*> show: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END HighlightAngle;
PROCEDURE Remove (view: T
    ; <*UNUSED*> p1: Euclid.Id
    ; <*UNUSED*> p2: Euclid.Id
    ; <*UNUSED*> p3: Euclid.Id
    ; <*UNUSED*> p4: Euclid.Id
    ; <*UNUSED*> show: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Remove;
PROCEDURE Step (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Step;


BEGIN
END EuclidViewClass.
