(* Copyright (C) 1995, Digital Equipment Corporation.       *)
(* All rights reserved.                                     *)
(* See the file COPYRIGHT for a full description.           *)
(*                                                          *)
(* Last modified on Thu Feb  9 08:56:54 PST 1995 by kalsow  *)
(*      modified on Sat Jun  4 16:23:08 1994 by heydon      *)
(*      modified on Wed Feb 17 17:04:32 PST 1993 by johnh   *)
(*      modified on Tue Jun  9 00:35:35 1992 by mhb         *)

(*********************************************************************
|*  NOTE: This file is generated automatically from the event
|*        definition file Hull.evt.
|*********************************************************************)

<* PRAGMA LL *>

MODULE HullViewClass;

<*NOWARN*> IMPORT HullFmt, HullAlgClass, IntList, ZeusClass;
<*NOWARN*> IMPORT SiteList, ViewClass;

REVEAL
  T = Public BRANDED OBJECT
      OVERRIDES
        <* LL.sup = VBT.mu *>
        isCompat := IsCompat;
        <* LL.sup < VBT.mu *>
        oeSetup := Setup;
        oeSetHalfPlane := SetHalfPlane;
        oeClearHead := ClearHead;
        oeTestSite := TestSite;
        oeClearTest := ClearTest;
        oeSetTail := SetTail;
        oeClearTail := ClearTail;
        oeMoveHalfPlane := MoveHalfPlane;
        oeConfirm := Confirm;
        oeDeny := Deny;
        oeSwap := Swap;
        oeSentinel := Sentinel;
        oeReOrder := ReOrder;
        oeStretch := Stretch;
        oeSnap := Snap;
        oeShuffle := Shuffle;
        <* LL.sup = VBT.mu *>
      END;

PROCEDURE IsCompat(<*UNUSED*> v: T; alg: ZeusClass.T): BOOLEAN =
  <* LL.sup = VBT.mu *>
  BEGIN
    RETURN ISTYPE(alg, HullAlgClass.T)
  END IsCompat;

PROCEDURE Setup (view: T
    ; <*UNUSED*> trueSites: SiteList.T
    ; <*UNUSED*> auxSites: SiteList.T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Setup;
PROCEDURE SetHalfPlane (view: T
    ; <*UNUSED*> tail: INTEGER
    ; <*UNUSED*> head: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END SetHalfPlane;
PROCEDURE ClearHead (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END ClearHead;
PROCEDURE TestSite (view: T
    ; <*UNUSED*> i: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END TestSite;
PROCEDURE ClearTest (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END ClearTest;
PROCEDURE SetTail (view: T
    ; <*UNUSED*> i: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END SetTail;
PROCEDURE ClearTail (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END ClearTail;
PROCEDURE MoveHalfPlane (view: T
    ; <*UNUSED*> tail: INTEGER
    ; <*UNUSED*> head: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END MoveHalfPlane;
PROCEDURE Confirm (view: T
    ; <*UNUSED*> tail: INTEGER
    ; <*UNUSED*> head: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Confirm;
PROCEDURE Deny (view: T
    ; <*UNUSED*> tail: INTEGER
    ; <*UNUSED*> head: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Deny;
PROCEDURE Swap (view: T
    ; <*UNUSED*> i: INTEGER
    ; <*UNUSED*> j: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Swap;
PROCEDURE Sentinel (view: T
    ; <*UNUSED*> i: INTEGER
    ; <*UNUSED*> j: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Sentinel;
PROCEDURE ReOrder (view: T
    ; <*UNUSED*> l: IntList.T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END ReOrder;
PROCEDURE Stretch (view: T
    ; <*UNUSED*> hullSites: IntList.T
    ; <*UNUSED*> otherSites: IntList.T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Stretch;
PROCEDURE Snap (view: T
    ; <*UNUSED*> hullSites: IntList.T
    ; <*UNUSED*> otherSites: IntList.T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Snap;
PROCEDURE Shuffle (view: T
    ; <*UNUSED*> hullSites: IntList.T
    ; <*UNUSED*> otherSites: IntList.T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Shuffle;


BEGIN
END HullViewClass.
