(* Copyright (C) 1995, Digital Equipment Corporation.       *)
(* All rights reserved.                                     *)
(* See the file COPYRIGHT for a full description.           *)
(*                                                          *)
(* Last modified on Thu Feb  9 08:47:37 PST 1995 by kalsow  *)
(* Last modified on Wed Feb 17 16:44:58 PST 1993 by johnh   *)
(*      modified on Tue Jun  9 00:35:07 1992 by mhb         *)

(*********************************************************************
|*  NOTE: This file is generated automatically from the event
|*        definition file Minimax.evt.
|*********************************************************************)

INTERFACE MinimaxAlgClass;

<*NOWARN*> IMPORT TypeFmt, Minimax, Algorithm, GameBoard;
<*NOWARN*> IMPORT AlgorithmClass;

<* PRAGMA LL *>

TYPE
  EventDataRec = RECORD
    stopAtSetup: BOOLEAN := TRUE;
    waitAtSetup: CARDINAL := 1;
    ctOfSetup: CARDINAL := 0;
    stopAtPlayerMove: BOOLEAN := TRUE;
    waitAtPlayerMove: CARDINAL := 1;
    ctOfPlayerMove: CARDINAL := 0;
    stopAtFinished: BOOLEAN := TRUE;
    waitAtFinished: CARDINAL := 1;
    ctOfFinished: CARDINAL := 0;
    stopAtEvaluateNode: BOOLEAN := TRUE;
    waitAtEvaluateNode: CARDINAL := 1;
    ctOfEvaluateNode: CARDINAL := 0;
    stopAtPlayerThinking: BOOLEAN := TRUE;
    waitAtPlayerThinking: CARDINAL := 1;
    ctOfPlayerThinking: CARDINAL := 0;
    stopAtFinishedEvalNode: BOOLEAN := TRUE;
    waitAtFinishedEvalNode: CARDINAL := 1;
    ctOfFinishedEvalNode: CARDINAL := 0;
    stopAtBoardValueUpdated: BOOLEAN := TRUE;
    waitAtBoardValueUpdated: CARDINAL := 1;
    ctOfBoardValueUpdated: CARDINAL := 0;
    stopAtHumanCellSelected: BOOLEAN := TRUE;
    waitAtHumanCellSelected: CARDINAL := 1;
    ctOfHumanCellSelected: CARDINAL := 0;
    stopAtHumanIllegalMove: BOOLEAN := TRUE;
    waitAtHumanIllegalMove: CARDINAL := 1;
    ctOfHumanIllegalMove: CARDINAL := 0;
  END;

  T <: Public;
  Public = Algorithm.T OBJECT
      eventDataRec: EventDataRec;

      METHODS
        feHumanSelection ( xCoord, yCoord: INTEGER);    <* LL = VBT.mu *>
      END;

REVEAL
  Algorithm.T <: AlgorithmClass.T;

END MinimaxAlgClass.
