(* Copyright (C) 1995, Digital Equipment Corporation.       *)
(* All rights reserved.                                     *)
(* See the file COPYRIGHT for a full description.           *)
(*                                                          *)
(* Last modified on Thu Feb  9 08:56:54 PST 1995 by kalsow  *)
(*      modified on Sat Jun  4 16:23:08 1994 by heydon      *)
(*      modified on Wed Feb 17 17:04:32 PST 1993 by johnh   *)
(*      modified on Tue Jun  9 00:35:35 1992 by mhb         *)

(*********************************************************************
|*  NOTE: This file is generated automatically from the event
|*        definition file Minimax.evt.
|*********************************************************************)

<* PRAGMA LL *>

MODULE MinimaxViewClass;

<*NOWARN*> IMPORT ZeusClass, TypeFmt, Minimax, MinimaxAlgClass;
<*NOWARN*> IMPORT GameBoard, ViewClass;

REVEAL
  T = Public BRANDED OBJECT
      OVERRIDES
        <* LL.sup = VBT.mu *>
        isCompat := IsCompat;
        <* LL.sup < VBT.mu *>
        oeSetup := Setup;
        oePlayerMove := PlayerMove;
        oeFinished := Finished;
        oeEvaluateNode := EvaluateNode;
        oePlayerThinking := PlayerThinking;
        oeFinishedEvalNode := FinishedEvalNode;
        oeBoardValueUpdated := BoardValueUpdated;
        oeHumanCellSelected := HumanCellSelected;
        oeHumanIllegalMove := HumanIllegalMove;
        <* LL.sup = VBT.mu *>
      END;

PROCEDURE IsCompat(<*UNUSED*> v: T; alg: ZeusClass.T): BOOLEAN =
  <* LL.sup = VBT.mu *>
  BEGIN
    RETURN ISTYPE(alg, MinimaxAlgClass.T)
  END IsCompat;

PROCEDURE Setup (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Setup;
PROCEDURE PlayerMove (view: T
    ; <*UNUSED*> player: INTEGER
    ; <*UNUSED*> fromx: INTEGER
    ; <*UNUSED*> fromy: INTEGER
    ; <*UNUSED*> tox: INTEGER
    ; <*UNUSED*> toy: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END PlayerMove;
PROCEDURE Finished (view: T
    ; <*UNUSED*> winner: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Finished;
PROCEDURE EvaluateNode (view: T
    ; <*UNUSED*> board: GameBoard.T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END EvaluateNode;
PROCEDURE PlayerThinking (view: T
    ; <*UNUSED*> player: INTEGER
    ; <*UNUSED*> board: GameBoard.T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END PlayerThinking;
PROCEDURE FinishedEvalNode (view: T
    ; <*UNUSED*> board: GameBoard.T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END FinishedEvalNode;
PROCEDURE BoardValueUpdated (view: T
    ; <*UNUSED*> board: GameBoard.T
    ; <*UNUSED*> newValue: Minimax.BoardValue
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END BoardValueUpdated;
PROCEDURE HumanCellSelected (view: T
    ; <*UNUSED*> xCoord: INTEGER
    ; <*UNUSED*> yCoord: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END HumanCellSelected;
PROCEDURE HumanIllegalMove (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END HumanIllegalMove;


BEGIN
END MinimaxViewClass.
