(* Copyright (C) 1995, Digital Equipment Corporation.       *)
(* All rights reserved.                                     *)
(* See the file COPYRIGHT for a full description.           *)
(*                                                          *)
(* Last modified on Thu Feb  9 08:56:54 PST 1995 by kalsow  *)
(*      modified on Sat Jun  4 16:23:08 1994 by heydon      *)
(*      modified on Wed Feb 17 17:04:32 PST 1993 by johnh   *)
(*      modified on Tue Jun  9 00:35:35 1992 by mhb         *)

(*********************************************************************
|*  NOTE: This file is generated automatically from the event
|*        definition file PQueue.evt.
|*********************************************************************)

<* PRAGMA LL *>

MODULE PQueueViewClass;

<*NOWARN*> IMPORT PQueue, ZeusClass, PQueueAlgClass, ViewClass;

REVEAL
  T = Public BRANDED OBJECT
      OVERRIDES
        <* LL.sup = VBT.mu *>
        isCompat := IsCompat;
        <* LL.sup < VBT.mu *>
        oeSetup := Setup;
        oeInitSort := InitSort;
        oeInsert := Insert;
        oeHeapOpInit := HeapOpInit;
        oeUpHeapStep := UpHeapStep;
        oeHeapStep := HeapStep;
        oePlaceElement := PlaceElement;
        oeRemove := Remove;
        oeCompare := Compare;
        oePause := Pause;
        oeSortStep := SortStep;
        <* LL.sup = VBT.mu *>
      END;

PROCEDURE IsCompat(<*UNUSED*> v: T; alg: ZeusClass.T): BOOLEAN =
  <* LL.sup = VBT.mu *>
  BEGIN
    RETURN ISTYPE(alg, PQueueAlgClass.T)
  END IsCompat;

PROCEDURE Setup (view: T
    ; <*UNUSED*> size: INTEGER
    ; <*UNUSED*> doSort: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Setup;
PROCEDURE InitSort (view: T
    ; <*UNUSED*> vals: PQueue.Array
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END InitSort;
PROCEDURE Insert (view: T
    ; <*UNUSED*> el: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Insert;
PROCEDURE HeapOpInit (view: T
    ; <*UNUSED*> k: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END HeapOpInit;
PROCEDURE UpHeapStep (view: T
    ; <*UNUSED*> k: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END UpHeapStep;
PROCEDURE HeapStep (view: T
    ; <*UNUSED*> k: INTEGER
    ; <*UNUSED*> n: INTEGER
    ; <*UNUSED*> down: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END HeapStep;
PROCEDURE PlaceElement (view: T
    ; <*UNUSED*> k: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END PlaceElement;
PROCEDURE Remove (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Remove;
PROCEDURE Compare (view: T
    ; <*UNUSED*> k: INTEGER
    ; <*UNUSED*> n: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Compare;
PROCEDURE Pause (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Pause;
PROCEDURE SortStep (view: T
    ; <*UNUSED*> k: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END SortStep;


BEGIN
END PQueueViewClass.
