(* Copyright (C) 1995, Digital Equipment Corporation.       *)
(* All rights reserved.                                     *)
(* See the file COPYRIGHT for a full description.           *)
(*                                                          *)
(* Last modified on Thu Feb  9 08:56:54 PST 1995 by kalsow  *)
(*      modified on Sat Jun  4 16:23:08 1994 by heydon      *)
(*      modified on Wed Feb 17 17:04:32 PST 1993 by johnh   *)
(*      modified on Tue Jun  9 00:35:35 1992 by mhb         *)

(*********************************************************************
|*  NOTE: This file is generated automatically from the event
|*        definition file PktRoute.evt.
|*********************************************************************)

<* PRAGMA LL *>

MODULE PktRouteViewClass;

<*NOWARN*> IMPORT TextConv, IntList, ZeusClass, IntListUtils;
<*NOWARN*> IMPORT PktRouteAlgClass, RefIntArray, ViewClass, OblFmt;

REVEAL
  T = Public BRANDED OBJECT
      OVERRIDES
        <* LL.sup = VBT.mu *>
        isCompat := IsCompat;
        <* LL.sup < VBT.mu *>
        oeStartGraph := StartGraph;
        oeNewNode := NewNode;
        oeNewStraightEdge := NewStraightEdge;
        oeNewCurvedEdge := NewCurvedEdge;
        oeNewLabel := NewLabel;
        oeEndGraph := EndGraph;
        oeStartPackets := StartPackets;
        oeNewPacket := NewPacket;
        oeEndPackets := EndPackets;
        oeBlocked := Blocked;
        oeMovePacket := MovePacket;
        oeQueueSizes := QueueSizes;
        oeAbsorb := Absorb;
        oeStep := Step;
        <* LL.sup = VBT.mu *>
      END;

PROCEDURE IsCompat(<*UNUSED*> v: T; alg: ZeusClass.T): BOOLEAN =
  <* LL.sup = VBT.mu *>
  BEGIN
    RETURN ISTYPE(alg, PktRouteAlgClass.T)
  END IsCompat;

PROCEDURE StartGraph (view: T
    ; <*UNUSED*> nodeCnt: CARDINAL
    ; <*UNUSED*> queueSize: CARDINAL
    ; <*UNUSED*> bounded: BOOLEAN
    ; <*UNUSED*> maxX: REAL
    ; <*UNUSED*> maxY: REAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END StartGraph;
PROCEDURE NewNode (view: T
    ; <*UNUSED*> id: CARDINAL
    ; <*UNUSED*> x: REAL
    ; <*UNUSED*> y: REAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewNode;
PROCEDURE NewStraightEdge (view: T
    ; <*UNUSED*> id1: CARDINAL
    ; <*UNUSED*> id2: CARDINAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewStraightEdge;
PROCEDURE NewCurvedEdge (view: T
    ; <*UNUSED*> id1: CARDINAL
    ; <*UNUSED*> id2: CARDINAL
    ; <*UNUSED*> x1: REAL
    ; <*UNUSED*> y1: REAL
    ; <*UNUSED*> x2: REAL
    ; <*UNUSED*> y2: REAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewCurvedEdge;
PROCEDURE NewLabel (view: T
    ; <*UNUSED*> label: TEXT
    ; <*UNUSED*> x: REAL
    ; <*UNUSED*> y: REAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewLabel;
PROCEDURE EndGraph (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END EndGraph;
PROCEDURE StartPackets (view: T
    ; <*UNUSED*> pktCnt: CARDINAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END StartPackets;
PROCEDURE NewPacket (view: T
    ; <*UNUSED*> id: CARDINAL
    ; <*UNUSED*> source: CARDINAL
    ; <*UNUSED*> dest: CARDINAL
    ; <*UNUSED*> fewestHops: CARDINAL
    ; <*UNUSED*> name: TEXT
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewPacket;
PROCEDURE EndPackets (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END EndPackets;
PROCEDURE Blocked (view: T
    ; <*UNUSED*> id: CARDINAL
    ; <*UNUSED*> from: CARDINAL
    ; <*UNUSED*> to: CARDINAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Blocked;
PROCEDURE MovePacket (view: T
    ; <*UNUSED*> id: CARDINAL
    ; <*UNUSED*> from: CARDINAL
    ; <*UNUSED*> to: CARDINAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END MovePacket;
PROCEDURE QueueSizes (view: T
    ; <*UNUSED*> sz: RefIntArray.T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END QueueSizes;
PROCEDURE Absorb (view: T
    ; <*UNUSED*> pktId: CARDINAL
    ; <*UNUSED*> node: CARDINAL
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Absorb;
PROCEDURE Step (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Step;


BEGIN
END PktRouteViewClass.
