(* Copyright (C) 1995, Digital Equipment Corporation.       *)
(* All rights reserved.                                     *)
(* See the file COPYRIGHT for a full description.           *)
(*                                                          *)
(* Last modified on Thu Feb  9 08:56:54 PST 1995 by kalsow  *)
(*      modified on Sat Jun  4 16:23:08 1994 by heydon      *)
(*      modified on Wed Feb 17 17:04:32 PST 1993 by johnh   *)
(*      modified on Tue Jun  9 00:35:35 1992 by mhb         *)

(*********************************************************************
|*  NOTE: This file is generated automatically from the event
|*        definition file Subtype.evt.
|*********************************************************************)

<* PRAGMA LL *>

MODULE SubtypeViewClass;

<*NOWARN*> IMPORT ZeusClass, SubtypeAlgClass, AlgSubtype;
<*NOWARN*> IMPORT ViewClass;

REVEAL
  T = Public BRANDED OBJECT
      OVERRIDES
        <* LL.sup = VBT.mu *>
        isCompat := IsCompat;
        <* LL.sup < VBT.mu *>
        oeSetup := Setup;
        oeBegin := Begin;
        oeNewBot := NewBot;
        oeNewTop := NewTop;
        oeNewFun := NewFun;
        oeNewDomRng := NewDomRng;
        oeNewLoop := NewLoop;
        oeEnter := Enter;
        oeExit := Exit;
        oeSeenOK := SeenOK;
        oeNotice := Notice;
        oeBotLessAnyOK := BotLessAnyOK;
        oeTopLessTopOK := TopLessTopOK;
        oeTopLessNonTopKO := TopLessNonTopKO;
        oeFunLessBotKO := FunLessBotKO;
        oeFunLessTopOK := FunLessTopOK;
        oeFunLessFun := FunLessFun;
        oeOK := OK;
        oeKO := KO;
        <* LL.sup = VBT.mu *>
      END;

PROCEDURE IsCompat(<*UNUSED*> v: T; alg: ZeusClass.T): BOOLEAN =
  <* LL.sup = VBT.mu *>
  BEGIN
    RETURN ISTYPE(alg, SubtypeAlgClass.T)
  END IsCompat;

PROCEDURE Setup (view: T
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Setup;
PROCEDURE Begin (view: T
    ; <*UNUSED*> lftRoot: INTEGER
    ; <*UNUSED*> rhtRoot: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Begin;
PROCEDURE NewBot (view: T
    ; <*UNUSED*> index: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewBot;
PROCEDURE NewTop (view: T
    ; <*UNUSED*> index: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewTop;
PROCEDURE NewFun (view: T
    ; <*UNUSED*> index: INTEGER
    ; <*UNUSED*> domEdgeIndex: INTEGER
    ; <*UNUSED*> rngEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewFun;
PROCEDURE NewDomRng (view: T
    ; <*UNUSED*> index: INTEGER
    ; <*UNUSED*> domIndex: INTEGER
    ; <*UNUSED*> rngIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewDomRng;
PROCEDURE NewLoop (view: T
    ; <*UNUSED*> fromIndex: INTEGER
    ; <*UNUSED*> toIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END NewLoop;
PROCEDURE Enter (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Enter;
PROCEDURE Exit (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> result: BOOLEAN
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Exit;
PROCEDURE SeenOK (view: T
    ; <*UNUSED*> fromIndex: INTEGER
    ; <*UNUSED*> toIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END SeenOK;
PROCEDURE Notice (view: T
    ; <*UNUSED*> fromIndex: INTEGER
    ; <*UNUSED*> toIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END Notice;
PROCEDURE BotLessAnyOK (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END BotLessAnyOK;
PROCEDURE TopLessTopOK (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END TopLessTopOK;
PROCEDURE TopLessNonTopKO (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END TopLessNonTopKO;
PROCEDURE FunLessBotKO (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END FunLessBotKO;
PROCEDURE FunLessTopOK (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END FunLessTopOK;
PROCEDURE FunLessFun (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END FunLessFun;
PROCEDURE OK (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END OK;
PROCEDURE KO (view: T
    ; <*UNUSED*> lftIndex: INTEGER
    ; <*UNUSED*> rhtIndex: INTEGER
    ; <*UNUSED*> lftLeadingEdgeIndex: INTEGER
    ; <*UNUSED*> rhtLeadingEdgeIndex: INTEGER
) =
  <* LL.sup < VBT.mu *>
  BEGIN
    view.evtHandled := FALSE;
  END KO;


BEGIN
END SubtypeViewClass.
