INTERFACE RsrcService_T_v1;

IMPORT TextSeq, Rd, Wr, StubLib, TextTextTbl, Thread, RsrcService, NetObj;
TYPE Surrogate_RsrcService_T = RsrcService.T OBJECT
      OVERRIDES
        readConfig := Surrogate_readConfig;
        setRsrcPath := Surrogate_setRsrcPath;
        getRsrcPath := Surrogate_getRsrcPath;
        getRsrcReader := Surrogate_getRsrcReader;
        getRsrcAsText := Surrogate_getRsrcAsText;
      END;

PROCEDURE Surrogate_readConfig(self: RsrcService.T; fn: TEXT)
     RAISES {NetObj.Error, RsrcService.E, Thread.Alerted};

PROCEDURE Surrogate_setRsrcPath(
    self: RsrcService.T;
    name: TEXT;
    rp: TextSeq.T) RAISES {NetObj.Error, RsrcService.E, Thread.Alerted};

PROCEDURE Surrogate_getRsrcPath(self: RsrcService.T; name: TEXT): TextSeq.T
     RAISES {NetObj.Error, RsrcService.E, Thread.Alerted};

PROCEDURE Surrogate_getRsrcReader(
    self: RsrcService.T;
    name: TEXT;
    env: TextTextTbl.T): Rd.T RAISES {NetObj.Error, RsrcService.E,
    Thread.Alerted};

PROCEDURE Surrogate_getRsrcAsText(
    self: RsrcService.T;
    name: TEXT;
    env: TextTextTbl.T): TEXT RAISES {NetObj.Error, RsrcService.E,
    Thread.Alerted};

PROCEDURE Stub_readConfig(
    self: RsrcService.T;
    c: StubLib.Conn;
    rep: StubLib.DataRep) RAISES {NetObj.Error, Rd.Failure, Wr.Failure,
    Thread.Alerted, RsrcService.E};

PROCEDURE Stub_setRsrcPath(
    self: RsrcService.T;
    c: StubLib.Conn;
    rep: StubLib.DataRep) RAISES {NetObj.Error, Rd.Failure, Wr.Failure,
    Thread.Alerted, RsrcService.E};

PROCEDURE Stub_getRsrcPath(
    self: RsrcService.T;
    c: StubLib.Conn;
    rep: StubLib.DataRep) RAISES {NetObj.Error, Rd.Failure, Wr.Failure,
    Thread.Alerted, RsrcService.E};

PROCEDURE Stub_getRsrcReader(
    self: RsrcService.T;
    c: StubLib.Conn;
    rep: StubLib.DataRep) RAISES {NetObj.Error, Rd.Failure, Wr.Failure,
    Thread.Alerted, RsrcService.E};

PROCEDURE Stub_getRsrcAsText(
    self: RsrcService.T;
    c: StubLib.Conn;
    rep: StubLib.DataRep) RAISES {NetObj.Error, Rd.Failure, Wr.Failure,
    Thread.Alerted, RsrcService.E};

END RsrcService_T_v1.
